import Qt 4.7

Rectangle {
    width: 800
    height: 430
    color: "#ffffff"

    Image {
        id: image1
        fillMode: Image.Stretch
        anchors.fill: parent
        source: "bg.jpg"


        Text {
            id: text_welcome
            x: 360
            y: 26
            width: 80
            height: 20
            color: "#07cee0"
            text: "Welcome to"
            styleColor: "#20f51c"
            font.family: "Nimbus Mono L"
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignTop
            font.bold: true
            font.pixelSize: 66
        }

        Text {
            id: text_aesypig
            x: 279
            y: 103
            color: "#f90707"
            text: "AesyPig"
            anchors.horizontalCenter: parent.horizontalCenter
            horizontalAlignment: Text.AlignLeft
            font.bold: true
            font.pixelSize: 77
        }


        Image {
            id: image_pig
            x: 412
            y: 64
            rotation: -47
            source: "pig.png"
        }

        Image {
            id: image_jiong
            x: 156
            y: 117
            source: "AesyPig.png"
        }

        Image {
            id: image_car
            x: 200
            y: 260
            scale: 1.5
            source: "qmap.png"

            MouseArea {
                id: mouse_areacar
                anchors.fill: parent
                onClicked:
                {
                    mainApp.toBaidumap();
                    //console.log("fuck....");
                }
            }
        }

        Text {
            id: text_car
//            x: 200
            y: 354
            anchors.horizontalCenter: image_car.horizontalCenter
            width: 132
            height: 39
            color: "#07ff0f"
            text: "百度地图"
            font.pixelSize: 33
        }



        Image {
            id: image_help
//            x: 684
//            y: 374
            anchors.right: parent.right
            anchors.bottom: parent.bottom
            width: 140
            height: 66
            smooth: false
            opacity: 0.6
            source: "button-lightblue.png"

            Text {
                id: text1
                text: "help"
                anchors.centerIn: parent
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 32

                MouseArea {
                    id: mouse_area1
                    anchors.fill: parent
                    onClicked:
                    {
                        mainApp.useBigInfobox("感谢使用AesyPig 0.2.0版本，以下是使用帮助<br>"
                                             + "1.此次更新更换了新的用户界面，大部分功能移动到了第二界面，在地图点击右下角的按钮即可；<br>"
                                             + "2.进入第二界面后正上方的白色输入框用于搜索地址，点击后在键盘输入即可;<br>"
                                             +   "（如有中文输入问题请先安装qt的mscim插件或参考论坛，也可以询问本作者）<br>"
                                             + "3.第二界面右边的路线按钮用于路线搜索功能，点击后会更换地址列表栏，再点击一次即可换回来；<br>"
                                             + "4.由于百度地图API的问题，使用前最好先设置所在城市；<br>"
                                           + "5.使用GPS定位前也最好设置所在城市；<br>"
                                             + "6.此版本已添加地图偏移修正功能，该功能需要网络支持，每10秒自动更新一次；<br>"
                                           + "7.不建议一直打开GPS功能，这样会增加耗电量；<br>"
                                             + "8.查询路线失败一般是地址重名导致，请输入一个更精确的地址，支持多关键字；<br>"
                                           + "如有意见请到code.google.com/p/qmap提出，谢谢。");
                    }
                }
            }

        }

    }

    //    ListModel{  //数据模型

//        id:listModel

//        ListElement{icon:"qbusmap.png"; file:"browser.qml"}

//        ListElement{icon:"qosmmap.png"; file:"osm"}

//        ListElement{icon:"qdrivemap.png"; file:"qdrivemap.qml"}

//        ListElement{icon:"meego_0.jpg"}

//    }

//    Component{     //代理

//        id:delegate

//        Item{ id:wrapper; width:100; height:100

//            scale:PathView.scale; opacity:PathView.opacity

//            Column{

//                Image
//                {
//                    source:icon;width:100;height:100
//                    MouseArea
//                    {
//                        anchors.fill:parent
//                        onClicked:
//                        {
//                            if (file == "browser.qml")
//                            {
//                                mainApp.toBusmap();
//                            }
//                            else if (file == "qdrivemap.qml")
//                            {
//                                mainApp.toDrivemap();
//                            }
//                            else if (file == "osm")
//                            {
//                                mainApp.toOsmmap();
//                            }
//                            console.log("fuck....");
//                        }
//                    }
//                }

//            }

//        }

//    }

//    PathView{
//        //路径视图

//        anchors.fill:parent; model:listModel; delegate:delegate

//        path:Path {
//            startX:400;startY:300

//            PathAttribute{name:"scale";value:2.0}
//            PathAttribute{name:"opacity";value:1.0}

//            PathQuad{x:400;y:-200;controlX:1100;controlY:-50}

//            PathAttribute{name:"scale";value:0.1}
//            PathAttribute{name:"opacity";value:0.5}

//            PathQuad{x:400;y:300;controlX:-300;controlY:-50}

//        }

//    }


}
